/*
// 本插件理论上支持4.1.1开始的所有版本的AutoJS
 // AutoJS Pro 9需要改为$plugins 不过pro建议直接使用官方的那个插件
 let $mlKitOcr = plugins.load('com.tony.mlkit.ocr')
 requestScreenCapture()
 let img = captureScreen()
 // 识别图片中的纯文本
 let text = $mlKitOcr.recognizeText(img)
 console.log('text:', text)
 // 可选参数 region[x, y, w, h] 识别指定区域的文本
 let textInRegion = $mlKitOcr.recognizeText(img, { region: [10, 10, 500, 1000] })
 console.log('text in region:', textInRegion)
 // 获取图片中文本携带位置信息
 let resultList = $mlKitOcr.detect(img)
 console.log('resultList:', JSON.stringify(resultList))
 // 可选参数region和上面的一样
 let resultListInRegion = $mlKitOcr.detect(img, { region: [10, 10, 500, 1000] })
 console.log('result list in region:', JSON.stringify(resultListInRegion))
 // 返回列表字段定义 返回的是一行的文本信息
 /*
 OcrResult {
 label: // 当前行文本信息
 bounds: // 所在区域 Rect 对象
 confidence: // 置信度 0->1
 elements: // OcrResult 行内拆分的元素
 }
 
 */
var $mlKitOcr,
    width = device.width,
    height = device.height;

var ocr_modular = {
    初始化Manager类: function(moniqi) {
        //适配模拟器平板版
        if (moniqi) {
            width = device.height
            height = device.width
        }
        importClass(android.os.Build);

        log("明日计划架构：" + Build.CPU_ABI)
        $mlKitOcr = plugins.load('com.tony.mlkit.ocr')
        log("OCR支持的架构：" + $mlKitOcr.get_ABI)
        if (device.product == "SM-G9750" && device.release == 9) {
            //"雷电9仅可使用x86-32位ocr插件\n\nhttps://234599.lanzouv.com/iyraG0fjzukf"
            return false
        }
        if (app.autojs.versionCode <= 8082200 && $mlKitOcr.get_ABI.indexOf('arm64-v8a') != -1) {
            return false
        }

        return true
    },
    识别: function(image, region_, filter) {
        switch (region_) {
            case '左':
                region_ = [0, 0, height / 2, width];
                break
            case '右':
                region_ = [height / 2, 0, height / 2, width]
                break
            case '上':
                region_ = [0, 0, height, width / 2];
                break
            case '下':
                region_ = [0, width / 2, height, width / 2]
                break
            case '左上':
                region_ = [0, 0, height / 2, width / 2]
                break
            case '右上':
                region_ = [height / 2, 0, height / 2, width / 2]
                break
            case '左下':
                region_ = [0, width / 2, height / 2, width / 2]
                break
            case '右下':
                region_ = [height / 2, width / 2, height / 2, width / 2]
                break
            case true:
            case undefined:
                region_ = [0, 0, height, width];
                break;
        }
        filter = filter || "公招";
        let start = new Date()
        let results = null;
        results = $mlKitOcr.detect(image, {
            region: region_,
        });
        !image.isRecycled() && image.recycle();


        var taglb = [];
        // 解析结果
        if (results != null) {
            let quantity = results.length;
            if (quantity > 0) {
                console.verbose("过滤识别结果中")
                for (let i = 0; i < quantity; i++) {
                    var re = results[i]
                    var retext = re.label
                    if (filter == "公招") {
                        switch (true) {
                            case retext.indexOf("0") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("1") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("2") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("3") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("4") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("6") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("7") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("8") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("9") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("得的千员") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("得的干员") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("新手") >= 0:
                                retext = "新手";
                                break;
                            case retext.indexOf("说明") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("时限") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("EPAR") >= 0:
                                retext = false;
                                break;
                            case retext.indexOf("联络次数") >= 0:
                                retext = false
                                break
                            case retext.indexOf("預算") >= 0:
                                retext = false
                                break
                            case retext.indexOf("预算") >= 0:
                                retext = false
                                break
                            case retext.indexOf("招募算") >= 0:
                                retext = false
                                break
                            case retext.indexOf("R") >= 0:
                                retext = false
                                break
                            case retext.indexOf("E") >= 0:
                                retext = false
                                break
                            case retext.indexOf("D") >= 0:
                                retext = false
                                break

                        }
                        if (retext == false) {
                            continue;
                        }
                        switch (retext) {

                            case "輸出":
                            case "輪出":
                                retext = "输出";
                                break
                            case "泊疗":
                            case "冶疗":
                            case "洽疗":
                                retext = "治疗";
                                break;
                            case "靳手":
                                retext = "新手";
                                break;

                            case "背男":
                                retext = "削弱";
                                break;
                            case "削写":
                                retext = "削弱";
                                break
                            case "削写写":
                                retext = "削弱";
                                break
                            case "削弱写":
                                retext = "削弱";
                                break;



                            case "近卫员":
                                retext = "近卫干员";
                                break
                            case "SPOT":
                                retext = "斑点";
                                break;
                            case "FANG":
                                retext = "芬";
                                break;
                            case "社宾":
                                retext = "杜宾";
                                break
                        }
                        retext = retext.replace(".", "")
                        retext = retext.replace('“', '')
                        retext = retext.replace('(', '')
                        retext = retext.replace('|', '')
                        retext = retext.replace("減", "减")
                        retext = retext.replace("滅", "减")
                        retext = retext.replace("减减速", "减速")
                        retext = retext.replace(/(祖击|租击|爼击)/g, "狙击")
                        retext = retext.replace(/(先鋒|先锋鋒)/g, "先锋");
                        retext = retext.replace(/(铺|輔)/g, "辅");

                        retext = retext.replace("級", "级");
                        retext = retext.replace("级级", "级");
                        retext = retext.replace("重裝", "重装")
                        retext = retext.replace("費用", "费用")
                        retext = retext.replace("逮", "速")
                        retext = retext.replace("遠", "速")
                        retext = retext.replace("快速速", "快速")
                        retext = retext.replace("攻兰莎", "玫兰莎")
                        retext = retext.replace("请流", "清流");
                        retext = retext.replace("朝羽", "翎羽");
                        retext = retext.replace(/(安賽尔|ANSEL)/g, "安赛尔");
                        retext = retext.replace(/(锄園解兰|请多多关照。)/g, "梓兰")
                        retext = retext.replace("蛇居箱", "蛇屠箱");

                        retext = retext.replace(/(资深员)/g, "资深干员")
                        retext = retext.replace("特神", "特种")
                        retext = retext.replace("米师", "术师")
                        retext = retext.replace(/(王员|千员|于员|午员)/g, "干员")
                        retext = retext.replace("剧新", "刷新")

                        retext = retext.replace(/(摄|缓)/g, "援")
                        retext = retext.replace("援援", "援")


                        switch (retext) {
                            case "联络中":
                            case "招募频算":

                            case "招算算":
                                break;
                            case "(最多3项)":
                                break;
                            case "(最多3项":
                                break;
                            case "职业需求":
                            case "职业需求·":
                                break;
                            case "招募时限":
                                break;
                            case ":":
                            case "、":
                            case ",":
                            case "g":
                                break;
                            case "每":
                                break;
                            case "低":
                                break;
                            case "(司":
                                break
                            case "主":
                                break;
                            case "这":
                            case "推":
                                break;
                            case "通":
                                break;
                            case "米":
                                break;
                            case "C":
                                break;
                            case "X":
                                break;
                            case "(回":
                            case "回":
                                break
                            case "可获得的干员":
                            case "可获得的千员":
                            case "·可获得的干员":
                                break;
                            case "招募说明":
                            case "招募说明k":
                                break;
                            case "招募说明>":
                                break;
                            case "招募说明》":
                                break;
                            default:
                                if (retext.split(" ").length == 1) {
                                    taglb.push({
                                        text: retext,
                                        x: re.bounds.left,
                                        y: re.bounds.top,
                                    });
                                } else {
                                    console.verbose("划分");
                                    retext = retext.split(" ");
                                    for (let k = 0; k < retext.length; k++) {
                                        switch (k) {
                                            case 0:
                                                taglb.push({
                                                    text: retext[k],
                                                    x: re.bounds.left,
                                                    y: re.bounds.top,
                                                })
                                                break
                                            case 1:
                                                taglb.push({
                                                    text: retext[k],
                                                    x: re.bounds.left + Math.floor(re.bounds.left / 3.5),
                                                    y: re.bounds.top,
                                                })
                                                break
                                            case 2:
                                                taglb.push({
                                                    text: retext[k],
                                                    x: re.bounds.left + Math.floor(re.bounds.left / 1.7),
                                                    y: re.bounds.top,
                                                })
                                                break
                                        }
                                    }

                                }


                        }

                    } else if (filter == "信用") {
                        switch (retext) {
                            case "未台":
                            case "赤全":
                                retext = "赤金";
                                break;
                            case "异鉄":
                                retext = "异铁";
                                break
                            case "碳秦":
                                retext = "碳素";
                                break

                            case "龙门市":
                                retext = "龙门币";
                                break
                        }
                        retext = retext.replace(" 320", "300")
                        retext = retext.replace("加忌急", "加急")
                        retext = retext.replace("技枝", "技")

                        retext = retext.replace("初級", "初级");
                        retext = retext.replace("初级級", "初级");
                        retext = retext.replace("加忌", "加急")
                        retext = retext.replace("加怠", "加急")
                        retext = retext.replace("家貝", "家具")
                        retext = retext.replace("雯件", "零件")

                        retext = retext.replace("传迷", "传递")
                        retext = retext.replace("自洽", "自治")
                        retext = retext.replace("黑纲", "黑钢")

                        taglb.push({
                            text: retext,
                            x: re.bounds.left,
                            y: re.bounds.top,
                        });
                    }
                }
            }
            if (taglb.length < 6 && filter != "信用") {
                for (let j = 0; j < quantity; j++) {
                    log(results[j].label)
                }
            }
            log("识别结果数量: " + quantity + '\n耗时' + (new Date() - start) + 'ms');
        };
        !image.isRecycled() && image.recycle();
        results = null;
        return taglb
    },
    销毁: function() {
        log("无需销毁模型")
    }
};
module.exports = ocr_modular;
events.on("exit", function() {
    sleep(2000);
})